//-----------------------------------------
// LScript Modeler Julienne 3d
//
// Copyright 2013 Michael Green
// mike@mikegreen.name
//

myversion=1.0;

@version 2.2
@warnings
@script modeler

// global values go here
c;
mybbox;
mypolys;
myfg;
mybg;
myundo=0;

main
{
    myfgs=lyrfg();
    myfg=myfgs[1];
    mybgs=lyrempty();
    mybg=mybgs[1];
    for(i=1;i<=3;i++)
    {
        myslice[i]    =   recall("MGJulienne3d"+i.asStr(),5);
    }

    selmode(USER);
    editbegin();
        mybbox=boundingbox();
        mychosenpolys=polygons;
        j=1;
        for(i=1;i<=mychosenpolys.size();i++)
        {
            if(!mychosenpolys[i].isCurve() && mychosenpolys[i].pointCount>2)
            {
                mypolys[j]=mychosenpolys[i];
                j++;
            }
        }
        if(!mypolys)
            error("This operation only works on polygons");
    editend();

    // requester code goes here

    reqbegin("MG Julienne 3d Ver:"+myversion);

    c[1] = ctlminislider("Number of slices X",myslice[1],1,100);
    c[2] = ctlminislider("Number of slices Y",myslice[2],1,100);
    c[3] = ctlminislider("Number of slices Z",myslice[3],1,100);

    myrefresh(0);

    ctlrefresh(c[1],"myrefresh");
    ctlrefresh(c[2],"myrefresh");
    ctlrefresh(c[3],"myrefresh");

    if (!reqpost())
    {
        if(myundo)
        {
//             undo();
//             undo();
//             undo();
            undo();
        }
        return;
    }

    // get requester control values here

    reqend();

    // processing code goes here


}
myrefresh:value
{
    if(myundo)
    {
            undo();
    }
	undogroupbegin();
    for(i=1;i<=3;i++)
    {
        myslice=getvalue(c[i]);
        myaxis=i;
        if(myslice<1)
        {
    	   myslice=1;
    	   setvalue(c[i],1);
        }
        myslice(myaxis,myslice,mybbox,myfg,mybg);
        store("MGJulienne3d"+i.asStr(),myslice);
    }
    undogroupend();
}

myslice:paxis, pslices, pbbox, pfg, pbg
{
    myundo=1;
    mylo=pbbox[1];
    myhi=pbbox[2];
    lyrsetfg(pbg);
    pslices=max(pslices,1);
    switch(paxis)
    {
        case 1:

            interval=(pbbox[2].x - pbbox[1].x)/pslices;
            if(!interval)
            {   
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x+interval*i,mylo.y - 1,mylo.z - 1>);
                    corner2=addpoint(<mylo.x+interval*i,myhi.y + 1,mylo.z - 1>);
                    corner3=addpoint(<mylo.x+interval*i,myhi.y + 1,myhi.z + 1>);
                    corner4=addpoint(<mylo.x+interval*i,mylo.y - 1,myhi.z + 1>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;

        case 2:
            interval=(pbbox[2].y - pbbox[1].y)/pslices;

            if(!interval)
            {
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x - 1,mylo.y +interval*i,mylo.z - 1>);
                    corner2=addpoint(<myhi.x + 1,mylo.y +interval*i,mylo.z - 1>);
                    corner3=addpoint(<myhi.x + 1,mylo.y +interval*i,myhi.z + 1>);
                    corner4=addpoint(<mylo.x - 1,mylo.y +interval*i,myhi.z + 1>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;

        case 3:
            interval=(pbbox[2].z - pbbox[1].z)/pslices;

            if(!interval)
            {   
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x - 1,mylo.y - 1,mylo.z +interval*i>);
                    corner2=addpoint(<myhi.x + 1,mylo.y - 1,mylo.z +interval*i>);
                    corner3=addpoint(<myhi.x + 1,myhi.y + 1,mylo.z +interval*i>);
                    corner4=addpoint(<mylo.x - 1,myhi.y + 1,mylo.z +interval*i>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;
    }


    lyrsetfg(pfg);
    lyrsetbg(pbg);
//    selpolygon(SET,POLYID,mypolys);
    soliddrill(SLICE);
    lyrsetfg(pbg);
    delete();
    lyrsetfg(pfg);

}

